<?php
/**
* Plugin to accept file uploads by email.
* @package TLE2
* @subpackage SecurityPlugins
* This plugin requires that the php IMAP extension be installed and enabled.
* An email address should be set up, with processed and problems folders.
*/

	/**
	* Loops through all emails currently in inbox, and uploads the attachments to the appropriate drafts folder
	*/
	function processEmails($folder) {
		global $config, $metrics, $database;
		//error_reporting(0); // don't want notice if inbox is empty

		$inbox_location = "{184.172.186.222/imap/tls/novalidate-cert}INBOX"; // *** replace with the location of your inbox
		$email_address = "ipad@nsapilot.co.uk"; // *** replace with your email address
		$email_password = "jmpw87GHJ65"; // *** replace with your email password
		
		$inbox = imap_open($inbox_location, $email_address, $email_password)
			 or die("can't connect: " . imap_last_error());
			 
		$MC = imap_check($inbox);
		/* Fetch an overview for all messages in INBOX */
		$result = imap_fetch_overview($inbox,"1:{$MC->Nmsgs}",0);
		foreach ($result as $overview) {
			$uid = $overview->msgno;
			$error = "";
			
			// BODY
			$struct = imap_fetchstructure($inbox,$uid);
			if (isset($struct->parts)) {
				foreach ($struct->parts as $part_key=>$part) {
					if (isset($part->disposition)) {
						if (strtolower($part->disposition) == 'attachment') {
							
							$filename = $part->dparameters[0]->value;
							// HEADER
							$h = imap_header($inbox,$uid);
							$subject = $h->subject;
							$sender_address = $h->from[0]->mailbox."@".$h->from[0]->host;
				
							/* get folder id from subject */
							$folder_id = (int)trim($subject);
							$folderId = $folder_id;
							$folder = Folder::getFolder($folderId);
							if ($folder == null) {
								$error = "Drafts folder not found. Please check ID.";
							} else {
								$folder_name = $folder->name;
								if ($folder_name != "Drafts") $error = "The specified folder is not a Drafts folder.";
								$simulation_id = $folder->projectid;
								$project = Project::GetProject($simulation_id);

								/* get user account from email address */
								/* - assumes one account per email address, check added to edit user page */
								$sql = sprintf("select * from users where email = '%s'",$sender_address);
								$results = $database->queryAssoc($sql);
								if (count($results) > 0) {
									$user_id = $results[0]['userid'];

									/* check that user has access to simulation */
									$permission_int = $project->GetProjectPermission('AddItem',$user_id);	
									if ($permission_int == 0) $error = "You do not have permissions for this simulation.";
								} else {
									$error = "You do not have permissions for this simulation.";
								}
								
							} // if ($folder == null) {
							
							if ($error != "") {
								/* move email to problems folder */
								imap_mail_move($inbox,$uid,"INBOX.problems");
								
								/* reply to user with error details */	
								$to      = $sender_address;
								$subject = 'SIMPLE document - error';
								$message = 'There was a problem uploading your document '.$filename.' - '.$error;
								$headers = 'From: ' . $email_address . "\r\n";
								mail($to, $subject, $message, $headers);								
								
							} else {

								$body = imap_fetchbody($inbox, $uid, $part_key+1);
								if ($part->encoding==4) {
									$body = quoted_printable_decode($body);
								} elseif ($part->encoding==3) {
									$body = base64_decode($body);
								}
								// no need to decode 7-bit, 8-bit, or binary
															
								//file_put_contents('plugins/EmailProcessor/attachments_temp/'.$filename, $body);
								
								/* upload to users drafts folder in simple */
								$item = Document::GetDocument(-1); // -1 for new document
								$item->filename = $filename;
								$item->content = $body;
								$item->contenttype="doc";
								$item->folderid = $folderId;
								$item->Save();
							
								/* send user a confirmation of upload */
								$to      = $sender_address;
								$subject = 'SIMPLE document - successfully uploaded';
								$message = 'The document '.$filename.' has been uploaded successfully.';
								$headers = 'From: ' . $email_address . "\r\n";
								mail($to, $subject, $message, $headers);
								
								/* move email to processed folder */
								imap_mail_move($inbox,$uid,"INBOX.processed");
							} // if ($error != "") {

						} // if (strtolower($part->disposition) == 'attachment') {
					} //if (isset($part->disposition)){
				} // foreach ($struct->parts as $part_key=>$part){
			} // if (isset($struct->parts)){
		} // end foreach message
		imap_expunge($inbox); // delete all the emails that have been flagged for deletion
		imap_close($inbox);	
			
	}
	$_PLUGINS->registerFunction('extendOfficeFoldersBefore','EmailProcessor','processEmails');

	?>